Last Comment Bug 746588 - [Azure] Cairo-pattern matrices specify the conversion from DrawTarget to pattern but Azure is inverted
: [Azure] Cairo-pattern matrices specify the conversion from DrawTarget to patt...
Status: RESOLVED FIXED
:
Product: Core
Classification: Components
Component: Graphics (show other bugs)
: unspecified
: x86 Mac OS X
: -- normal (vote)
: mozilla14
Assigned To: George Wright (:gw280) (:gwright)
:
Mentors:
Depends on:
Blocks: 740580
  Show dependency treegraph
 
Reported: 2012-04-18 08:23 PDT by George Wright (:gw280) (:gwright)
Modified: 2012-04-23 16:17 PDT (History)
3 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
invert the matrix in SetMatrix (774 bytes, patch)
2012-04-18 08:25 PDT, George Wright (:gw280) (:gwright)
jmuizelaar: review+
akeybl: approval‑mozilla‑central+
Details | Diff | Review

Description George Wright (:gw280) (:gwright) 2012-04-18 08:23:53 PDT
Matrices in Azure specify the conversion from pattern to DT space; we do not handle this in gfxPattern.cpp in SetMatrix()
Comment 1 George Wright (:gw280) (:gwright) 2012-04-18 08:25:28 PDT
Created attachment 616152 [details] [diff] [review]
invert the matrix in SetMatrix

Patch from Bas
Comment 2 Jeff Muizelaar [:jrmuizel] 2012-04-18 08:45:01 PDT
Comment on attachment 616152 [details] [diff] [review]
invert the matrix in SetMatrix

Review of attachment 616152 [details] [diff] [review]:
-----------------------------------------------------------------

Does this affect D2D?
Comment 3 Jeff Muizelaar [:jrmuizel] 2012-04-18 09:26:19 PDT
Comment on attachment 616152 [details] [diff] [review]
invert the matrix in SetMatrix

Review of attachment 616152 [details] [diff] [review]:
-----------------------------------------------------------------

Does this affect D2D?
Comment 4 Brad Lassey [:blassey] (use needinfo?) 2012-04-19 09:59:07 PDT
Comment on attachment 616152 [details] [diff] [review]
invert the matrix in SetMatrix

Review of attachment 616152 [details] [diff] [review]:
-----------------------------------------------------------------

::: gfx/thebes/gfxPattern.cpp
@@ +134,5 @@
>      mTransform = ToMatrix(matrix);
> +    // Cairo-pattern matrices specify the conversion from DrawTarget to pattern
> +    // space. Azure pattern matrices specify the conversion from pattern to
> +    // DrawTarget space.
> +    mTransform.Invert();

should this be azure only then?
Comment 5 George Wright (:gw280) (:gwright) 2012-04-19 10:00:22 PDT
Yes, this only affects azure for content drawing with basic layers.
Comment 6 Alex Keybl [:akeybl] 2012-04-20 15:43:16 PDT
Comment on attachment 616152 [details] [diff] [review]
invert the matrix in SetMatrix

[Triage Comment]
Desktop only, approved for central.
Comment 7 George Wright (:gw280) (:gwright) 2012-04-23 10:30:30 PDT
https://hg.mozilla.org/integration/mozilla-inbound/rev/d400d7f9eadd
Comment 8 :Ehsan Akhgari (busy, don't ask for review please) 2012-04-23 16:17:52 PDT
https://hg.mozilla.org/mozilla-central/rev/d400d7f9eadd

Note You need to log in before you can comment on or make changes to this bug.